diff --git a/gcc/config/tilepro/tilepro.c b/gcc/config/tilepro/tilepro.c
index 74f8800..8ef5f7e 100644
--- a/gcc/config/tilepro/tilepro.c
+++ b/gcc/config/tilepro/tilepro.c
@@ -86,8 +86,8 @@ tilepro_option_override (void)
 {
   /* When modulo scheduling is enabled, we still rely on regular
      scheduler for bundling.  */
-  if (flag_modulo_sched)
-    flag_resched_modulo_sched = 1;
+  if (GCC_OPTION (flag_modulo_sched))
+    GCC_OPTION (flag_resched_modulo_sched) = 1;
 }
 
 
@@ -299,12 +299,12 @@ tilepro_build_builtin_va_list (void)
 
   /* We know this is being padded and we want it too.  It is an
      internal type so hide the warnings from the user.  */
-  owp = warn_padded;
-  warn_padded = false;
+  owp = GCC_OPTION (warn_padded);
+  GCC_OPTION (warn_padded) = false;
 
   layout_type (record);
 
-  warn_padded = owp;
+  GCC_OPTION (warn_padded) = owp;
 
   /* The correct type is an array type of one element.  */
   return record;
@@ -686,7 +686,7 @@ tilepro_init_expanders (void)
      status.  */
   init_machine_status = tilepro_init_machine_status;
 
-  if (cfun && cfun->machine && flag_pic)
+  if (cfun && cfun->machine && GCC_OPTION (flag_pic))
     {
       static int label_num = 0;
 
@@ -869,7 +869,7 @@ static rtx
 tilepro_tls_got (void)
 {
   rtx temp;
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       crtl->uses_pic_offset_table = 1;
       return tilepro_got_rtx ();
@@ -1025,8 +1025,8 @@ tilepro_legitimize_pic_address (rtx orig,
 	     optimized properly.  */
 	  rtx temp_reg = create_temp_reg_if_possible (Pmode, reg);
 
-	  gcc_assert (flag_pic);
-	  if (flag_pic == 1)
+	  gcc_assert (GCC_OPTION (flag_pic));
+	  if (GCC_OPTION (flag_pic) == 1)
 	    {
 	      emit_insn (gen_add_got16 (temp_reg,
 					tilepro_got_rtx (), orig));
@@ -1136,7 +1136,7 @@ tilepro_legitimize_address (rtx x, rtx oldx ATTRIBUTE_UNUSED,
     {
       return tilepro_legitimize_tls_address (x);
     }
-  else if (flag_pic)
+  else if (GCC_OPTION (flag_pic))
     {
       return tilepro_legitimize_pic_address (x, mode, 0);
     }
@@ -1173,12 +1173,12 @@ tilepro_delegitimize_address (rtx x)
 static void
 load_pic_register (bool delay_pic_helper ATTRIBUTE_UNUSED)
 {
-  int orig_flag_pic = flag_pic;
+  int orig_flag_pic = GCC_OPTION (flag_pic);
 
   rtx got_symbol = tilepro_got_symbol ();
   rtx text_label_symbol = tilepro_text_label_symbol ();
   rtx text_label_rtx = tilepro_text_label_rtx ();
-  flag_pic = 0;
+  GCC_OPTION (flag_pic) = 0;
 
   emit_insn (gen_insn_lnk_and_label (text_label_rtx, text_label_symbol));
 
@@ -1189,7 +1189,7 @@ load_pic_register (bool delay_pic_helper ATTRIBUTE_UNUSED)
 			     tilepro_got_rtx (),
 			     got_symbol, text_label_symbol));
 
-  flag_pic = orig_flag_pic;
+  GCC_OPTION (flag_pic) = orig_flag_pic;
 
   /* Need to emit this whether or not we obey regdecls, since
      setjmp/longjmp can cause life info to screw up.  ??? In the case
@@ -1491,7 +1491,7 @@ tilepro_expand_mov (enum machine_mode mode, rtx *operands)
     }
 
   /* Fixup PIC cases.  */
-  if (flag_pic && CONSTANT_P (operands[1]))
+  if (GCC_OPTION (flag_pic) && CONSTANT_P (operands[1]))
     {
       if (tilepro_pic_address_needs_scratch (operands[1]))
 	operands[1] = tilepro_legitimize_pic_address (operands[1], mode, 0);
@@ -1508,7 +1508,7 @@ tilepro_expand_mov (enum machine_mode mode, rtx *operands)
     }
 
   /* Fixup for UNSPEC addresses.  */
-  if (flag_pic
+  if (GCC_OPTION (flag_pic)
       && GET_CODE (operands[1]) == HIGH
       && GET_CODE (XEXP (operands[1], 0)) == CONST
       && GET_CODE (XEXP (XEXP (operands[1], 0), 0)) == UNSPEC)
@@ -1522,7 +1522,7 @@ tilepro_expand_mov (enum machine_mode mode, rtx *operands)
 				     XVECEXP (unspec, 0, 1)));
 	  return true;
 	}
-      else if (flag_pic == 2 && unspec_num == UNSPEC_GOT32_SYM)
+      else if (GCC_OPTION (flag_pic) == 2 && unspec_num == UNSPEC_GOT32_SYM)
 	{
 	  emit_insn (gen_addhi_got32 (operands[0], const0_rtx,
 				      XVECEXP (unspec, 0, 0)));
@@ -2555,7 +2555,7 @@ tilepro_output_cbranch (rtx insn, rtx *operands, bool reversed)
 void
 tilepro_expand_tablejump (rtx op0, rtx op1)
 {
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       rtx table = gen_rtx_LABEL_REF (Pmode, op1);
       rtx temp = gen_reg_rtx (Pmode);
@@ -3221,7 +3221,7 @@ need_to_save_reg (unsigned int regno)
       && df_regs_ever_live_p (regno))
     return true;
 
-  if (flag_pic
+  if (GCC_OPTION (flag_pic)
       && (regno == PIC_OFFSET_TABLE_REGNUM
 	  || regno == TILEPRO_PIC_TEXT_LABEL_REGNUM)
       && (crtl->uses_pic_offset_table || crtl->saves_all_registers))
@@ -3536,7 +3536,7 @@ tilepro_expand_prologue (void)
 
   int total_size = compute_total_frame_size ();
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = total_size;
 
   /* Save lr first in its special location because code after this
@@ -3548,7 +3548,7 @@ tilepro_expand_prologue (void)
   if (total_size == 0)
     {
       /* Load the PIC register if needed.  */
-      if (flag_pic && crtl->uses_pic_offset_table)
+      if (GCC_OPTION (flag_pic) && crtl->uses_pic_offset_table)
 	load_pic_register (false);
 
       return;
@@ -3669,7 +3669,7 @@ tilepro_expand_prologue (void)
     emit_insn (gen_blockage ());
 
   /* Load the PIC register if needed.  */
-  if (flag_pic && crtl->uses_pic_offset_table)
+  if (GCC_OPTION (flag_pic) && crtl->uses_pic_offset_table)
     load_pic_register (false);
 }
 
@@ -3791,7 +3791,7 @@ tilepro_expand_epilogue (bool sibcall_p)
     }
 
   /* Mark the pic registers as live outside of the function.  */
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       emit_use (cfun->machine->text_label_rtx);
       emit_use (cfun->machine->got_rtx);
@@ -4037,7 +4037,7 @@ replace_pc_relative_symbol_ref (rtx insn, rtx opnds[4], bool first_insn_p)
 
   start_sequence ();
 
-  if (flag_pic == 1)
+  if (GCC_OPTION (flag_pic) == 1)
     {
       if (!first_insn_p)
 	{
@@ -4320,12 +4320,12 @@ tilepro_reorg (void)
      now.  */
   compute_bb_for_insn ();
 
-  if (flag_reorder_blocks_and_partition)
+  if (GCC_OPTION (flag_reorder_blocks_and_partition))
     {
       tilepro_fixup_pcrel_references ();
     }
 
-  if (flag_schedule_insns_after_reload)
+  if (GCC_OPTION (flag_schedule_insns_after_reload))
     {
       split_all_insns ();
 
@@ -4339,7 +4339,7 @@ tilepro_reorg (void)
 
   df_analyze ();
 
-  if (flag_var_tracking)
+  if (GCC_OPTION (flag_var_tracking))
     {
       timevar_push (TV_VAR_TRACKING);
       variable_tracking_main ();
@@ -4694,10 +4694,10 @@ tilepro_print_operand (FILE *file, rtx x, int code)
     case 'p':
       if (GET_CODE (x) == SYMBOL_REF)
 	{
-	  if (flag_pic && !SYMBOL_REF_LOCAL_P (x))
+	  if (GCC_OPTION (flag_pic) && !SYMBOL_REF_LOCAL_P (x))
 	    fprintf (file, "plt(");
 	  output_addr_const (file, x);
-	  if (flag_pic && !SYMBOL_REF_LOCAL_P (x))
+	  if (GCC_OPTION (flag_pic) && !SYMBOL_REF_LOCAL_P (x))
 	    fprintf (file, ")");
 	}
       else
@@ -4925,7 +4925,7 @@ tilepro_function_profiler (FILE *file, int labelno ATTRIBUTE_UNUSED)
       fprintf (file, "\t}\n");
     }
 
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     {
       fprintf (file,
 	       "\t{\n"
diff --git a/gcc/config/tilepro/tilepro.h b/gcc/config/tilepro/tilepro.h
index 0c5e87c..afb5e18 100644
--- a/gcc/config/tilepro/tilepro.h
+++ b/gcc/config/tilepro/tilepro.h
@@ -134,8 +134,8 @@
 
 /* Register that holds an address into the text segment that can be
    used by pic code.  */
-#define TILEPRO_PIC_TEXT_LABEL_REGNUM (flag_pic ? 50 : INVALID_REGNUM)
-#define PIC_OFFSET_TABLE_REGNUM (flag_pic ? 51 : INVALID_REGNUM)
+#define TILEPRO_PIC_TEXT_LABEL_REGNUM (GCC_OPTION (flag_pic) ? 50 : INVALID_REGNUM)
+#define PIC_OFFSET_TABLE_REGNUM (GCC_OPTION (flag_pic) ? 51 : INVALID_REGNUM)
 #define HARD_FRAME_POINTER_REGNUM 52
 #define THREAD_POINTER_REGNUM 53
 #define STACK_POINTER_REGNUM 54
diff --git a/gcc/config/v850/v850.c b/gcc/config/v850/v850.c
index eb19326..3240ecc 100644
--- a/gcc/config/v850/v850.c
+++ b/gcc/config/v850/v850.c
@@ -1130,7 +1130,7 @@ substitute_ep_register (rtx first_insn,
       *p_ep = gen_rtx_REG (Pmode, 30);
     }
 
-  if (TARGET_DEBUG)
+  if (GCC_OPTION (TARGET_DEBUG))
     fprintf (stderr, "\
 Saved %d bytes (%d uses of register %s) in function %s, starting as insn %d, ending at %d\n",
 	     2 * (uses - 3), uses, reg_names[regno],
@@ -1590,7 +1590,7 @@ use_prolog_function (int num_save, int frame_size)
   if (! TARGET_DISABLE_CALLT)
       save_func_len = restore_func_len = 2;
   else
-      save_func_len = restore_func_len = TARGET_LONG_CALLS ? (4+4+4+2+2) : 4;
+      save_func_len = restore_func_len = GCC_OPTION (TARGET_LONG_CALLS) ? (4+4+4+2+2) : 4;
 
   if (unalloc_stack)
     {
@@ -1654,7 +1654,7 @@ expand_prologue (void)
 
   actual_fsize = compute_frame_size (size, &reg_saved);
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = actual_fsize;
 
   /* Save/setup global registers for interrupt functions right now.  */
@@ -1711,7 +1711,7 @@ expand_prologue (void)
 	  save_all = gen_rtx_PARALLEL
 	    (VOIDmode,
 	     rtvec_alloc (num_save + 1
-			  + (TARGET_DISABLE_CALLT ? (TARGET_LONG_CALLS ? 2 : 1) : 0)));
+			  + (TARGET_DISABLE_CALLT ? (GCC_OPTION (TARGET_LONG_CALLS) ? 2 : 1) : 0)));
 
 	  XVECEXP (save_all, 0, 0)
 	    = gen_rtx_SET (VOIDmode,
@@ -1736,7 +1736,7 @@ expand_prologue (void)
 	      XVECEXP (save_all, 0, num_save + 1)
 		= gen_rtx_CLOBBER (VOIDmode, gen_rtx_REG (Pmode, 10));
 
-	      if (TARGET_LONG_CALLS)
+	      if (GCC_OPTION (TARGET_LONG_CALLS))
 		XVECEXP (save_all, 0, num_save + 2)
 		  = gen_rtx_CLOBBER (VOIDmode, gen_rtx_REG (Pmode, 11));
 	    }
@@ -2208,13 +2208,13 @@ v850_encode_data_area (tree decl, rtx symbol)
 	  if (size <= 0)
 	    ;
 
-	  else if (size <= small_memory_max [(int) SMALL_MEMORY_TDA])
+	  else if (size <= GCC_OPTION (small_memory_max) [(int) SMALL_MEMORY_TDA])
 	    v850_set_data_area (decl, DATA_AREA_TDA);
 
-	  else if (size <= small_memory_max [(int) SMALL_MEMORY_SDA])
+	  else if (size <= GCC_OPTION (small_memory_max) [(int) SMALL_MEMORY_SDA])
 	    v850_set_data_area (decl, DATA_AREA_SDA);
 
-	  else if (size <= small_memory_max [(int) SMALL_MEMORY_ZDA])
+	  else if (size <= GCC_OPTION (small_memory_max) [(int) SMALL_MEMORY_ZDA])
 	    v850_set_data_area (decl, DATA_AREA_ZDA);
 	}
       
@@ -2325,7 +2325,7 @@ construct_restore_jr (rtx op)
      be popping more registers than is strictly necessary, but
      it does save code space.  */
   
-  if (TARGET_LONG_CALLS)
+  if (GCC_OPTION (TARGET_LONG_CALLS))
     {
       char name[40];
       
@@ -2365,7 +2365,7 @@ construct_save_jarl (rtx op)
   int i;
   static char buff [100]; /* XXX */
   
-  if (count <= (TARGET_LONG_CALLS ? 3 : 2)) 
+  if (count <= (GCC_OPTION (TARGET_LONG_CALLS) ? 3 : 2)) 
     {
       error ("bogus JARL construction: %d", count);
       return NULL;
@@ -2382,7 +2382,7 @@ construct_save_jarl (rtx op)
   stack_bytes = INTVAL (XEXP (SET_SRC (XVECEXP (op, 0, 0)), 1));
 
   /* Each push will put 4 bytes from the stack....  */
-  stack_bytes += (count - (TARGET_LONG_CALLS ? 3 : 2)) * 4;
+  stack_bytes += (count - (GCC_OPTION (TARGET_LONG_CALLS) ? 3 : 2)) * 4;
 
   /* Make sure that the amount we are popping either 0 or 16 bytes.  */
   if (stack_bytes != 0)
@@ -2393,7 +2393,7 @@ construct_save_jarl (rtx op)
 
   /* Now compute the bit mask of registers to push.  */
   mask = 0;
-  for (i = 1; i < count - (TARGET_LONG_CALLS ? 2 : 1); i++)
+  for (i = 1; i < count - (GCC_OPTION (TARGET_LONG_CALLS) ? 2 : 1); i++)
     {
       rtx vector_element = XVECEXP (op, 0, i);
       
@@ -2432,7 +2432,7 @@ construct_save_jarl (rtx op)
      be pushing more registers than is strictly necessary, but
      it does save code space.  */
   
-  if (TARGET_LONG_CALLS)
+  if (GCC_OPTION (TARGET_LONG_CALLS))
     {
       char name[40];
       
@@ -3097,7 +3097,7 @@ v850_adjust_insn_length (rtx insn, int length)
     {
       if (CALL_P (insn))
 	{
-	  if (TARGET_LONG_CALLS)
+	  if (GCC_OPTION (TARGET_LONG_CALLS))
 	    {
 	      /* call_internal_long, call_value_internal_long.  */
 	      if (length == 8)
@@ -3138,12 +3138,12 @@ static const struct attribute_spec v850_attribute_table[] =
 static void
 v850_option_override (void)
 {
-  if (flag_exceptions || flag_non_call_exceptions)
-    flag_omit_frame_pointer = 0;
+  if (GCC_OPTION (flag_exceptions) || GCC_OPTION (flag_non_call_exceptions))
+    GCC_OPTION (flag_omit_frame_pointer) = 0;
 
   /* The RH850 ABI does not (currently) support the use of the CALLT instruction.  */
   if (! TARGET_GCC_ABI)
-    target_flags |= MASK_DISABLE_CALLT;
+    GCC_OPTION (target_flags) |= MASK_DISABLE_CALLT;
 }
 
 const char *
diff --git a/gcc/config/v850/v850.h b/gcc/config/v850/v850.h
index 92db20a4..752a0aa 100644
--- a/gcc/config/v850/v850.h
+++ b/gcc/config/v850/v850.h
@@ -195,7 +195,7 @@ extern GTY(()) rtx v850_compare_op1;
 
 /* Allocation boundary (in *bits*) for the code of a function.
    16 is the minimum boundary; 32 would give better performance.  */
-#define FUNCTION_BOUNDARY 	(((! TARGET_GCC_ABI) || optimize_size) ? 16 : 32)
+#define FUNCTION_BOUNDARY 	(((! TARGET_GCC_ABI) || GCC_OPTION (optimize_size)) ? 16 : 32)
 
 /* No data type wants to be aligned rounder than this.  */
 #define BIGGEST_ALIGNMENT	(TARGET_8BYTE_ALIGN ? 64 : 32)
diff --git a/gcc/config/vax/elf.h b/gcc/config/vax/elf.h
index d6041dc..b8376b9 100644
--- a/gcc/config/vax/elf.h
+++ b/gcc/config/vax/elf.h
@@ -79,8 +79,8 @@ along with GCC; see the file COPYING3.  If not see
   do							\
     {							\
       /* Turn off function CSE if we're doing PIC.  */	\
-      if (flag_pic)					\
-	flag_no_function_cse = 1;			\
+      if (GCC_OPTION (flag_pic))					\
+	GCC_OPTION (flag_no_function_cse) = 1;			\
     }							\
   while (0)
 
diff --git a/gcc/config/vax/vax.c b/gcc/config/vax/vax.c
index 2b152fd..42fe18d 100644
--- a/gcc/config/vax/vax.c
+++ b/gcc/config/vax/vax.c
@@ -227,7 +227,7 @@ vax_file_start (void)
 {
   default_file_start ();
 
-  if (write_symbols == DBX_DEBUG)
+  if (GCC_OPTION (write_symbols) == DBX_DEBUG)
     fprintf (asm_out_file, "___vax_%c_doubles:\n", ASM_DOUBLE_CHAR);
 }
 
@@ -265,7 +265,7 @@ split_quadword_operands (rtx insn, enum rtx_code code, rtx * operands,
 	  rtx addr = XEXP (operands[i], 0);
 	  operands[i] = low[i] = gen_rtx_MEM (SImode, addr);
 	}
-      else if (optimize_size && MEM_P (operands[i])
+      else if (GCC_OPTION (optimize_size) && MEM_P (operands[i])
 	       && REG_P (XEXP (operands[i], 0))
 	       && (code != MINUS || operands[1] != const0_rtx)
 	       && find_regno_note (insn, REG_DEAD,
@@ -437,10 +437,10 @@ print_operand_address (FILE * file, rtx addr)
       if (reg1)
 	{
 	  if (breg
-	      || (flag_pic && GET_CODE (addr) == SYMBOL_REF)
+	      || (GCC_OPTION (flag_pic) && GET_CODE (addr) == SYMBOL_REF)
 	      || (offset
 		  && (MEM_P (offset)
-		      || (flag_pic && symbolic_operand (offset, SImode)))))
+		      || (GCC_OPTION (flag_pic) && symbolic_operand (offset, SImode)))))
 	    {
 	      gcc_assert (!ireg);
 	      ireg = reg1;
@@ -451,7 +451,7 @@ print_operand_address (FILE * file, rtx addr)
 
       if (offset != 0)
 	{
-	  if (flag_pic && symbolic_operand (offset, SImode))
+	  if (GCC_OPTION (flag_pic) && symbolic_operand (offset, SImode))
 	    {
 	      if (breg && ireg)
 		{
@@ -460,7 +460,7 @@ print_operand_address (FILE * file, rtx addr)
 		}
 
 #ifdef NO_EXTERNAL_INDIRECT_ADDRESS
-	      if (flag_pic > 1 && GET_CODE (offset) == CONST
+	      if (GCC_OPTION (flag_pic) > 1 && GET_CODE (offset) == CONST
 		  && GET_CODE (XEXP (XEXP (offset, 0), 0)) == SYMBOL_REF
 		  && !SYMBOL_REF_LOCAL_P (XEXP (XEXP (offset, 0), 0)))
 		{
@@ -550,7 +550,7 @@ print_operand (FILE *file, rtx x, int code)
     }
   else
     {
-      if (flag_pic > 1 && symbolic_operand (x, SImode))
+      if (GCC_OPTION (flag_pic) > 1 && symbolic_operand (x, SImode))
 	{
 	  debug_rtx (x);
 	  output_operand_lossage ("symbol used as immediate operand");
@@ -1143,7 +1143,7 @@ vax_output_int_move (rtx insn ATTRIBUTE_UNUSED, rtx *operands,
     case DImode:
       if (operands[1] == const0_rtx)
 	return "clrq %0";
-      if (TARGET_QMATH && optimize_size
+      if (TARGET_QMATH && GCC_OPTION (optimize_size)
 	  && (CONST_INT_P (operands[1])
 	      || GET_CODE (operands[1]) == CONST_DOUBLE))
 	{
@@ -1279,7 +1279,7 @@ vax_output_int_move (rtx insn ATTRIBUTE_UNUSED, rtx *operands,
 	    return "movzbl %1,%0";
 	  if (i >= -0x80 && i < 0)
 	    return "cvtbl %1,%0";
-	  if (optimize_size
+	  if (GCC_OPTION (optimize_size)
 	      && (n = exact_log2 (i & (-i))) != -1
 	      && ((unsigned HOST_WIDE_INT)i >> n) < 64)
 	    {
@@ -1364,8 +1364,8 @@ vax_output_int_add (rtx insn, rtx *operands, enum machine_mode mode)
 	  {
 	    gcc_assert (rtx_equal_p (operands[0], operands[1]));
 #ifdef NO_EXTERNAL_INDIRECT_ADDRESSS
-	    gcc_assert (!flag_pic || !external_memory_operand (low[2], SImode));
-	    gcc_assert (!flag_pic || !external_memory_operand (low[0], SImode));
+	    gcc_assert (!GCC_OPTION (flag_pic) || !external_memory_operand (low[2], SImode));
+	    gcc_assert (!GCC_OPTION (flag_pic) || !external_memory_operand (low[0], SImode));
 #endif
 
 	    /* No reason to add a 0 to the low part and thus no carry, so just
@@ -1499,11 +1499,11 @@ vax_output_int_add (rtx insn, rtx *operands, enum machine_mode mode)
 	  return "movab %a1[%2],%0";
 	}
 
-      if (flag_pic && REG_P (operands[0])
+      if (GCC_OPTION (flag_pic) && REG_P (operands[0])
 	  && symbolic_operand (operands[2], SImode))
 	return "movab %a2,%0;addl2 %1,%0";
 
-      if (flag_pic
+      if (GCC_OPTION (flag_pic)
 	  && (symbolic_operand (operands[1], SImode)
 	      || symbolic_operand (operands[1], SImode)))
 	debug_rtx (insn);
@@ -1639,7 +1639,7 @@ legitimate_constant_address_p (rtx x)
   if (GET_CODE (x) != CONST)
     return false;
 #ifdef NO_EXTERNAL_INDIRECT_ADDRESS
-  if (flag_pic
+  if (GCC_OPTION (flag_pic)
       && GET_CODE (XEXP (XEXP (x, 0), 0)) == SYMBOL_REF
       && !SYMBOL_REF_LOCAL_P (XEXP (XEXP (x, 0), 0)))
     return false;
@@ -1668,10 +1668,10 @@ static bool
 indirectable_constant_address_p (rtx x, bool indirect)
 {
   if (GET_CODE (x) == SYMBOL_REF)
-    return !flag_pic || SYMBOL_REF_LOCAL_P (x) || !indirect;
+    return !GCC_OPTION (flag_pic) || SYMBOL_REF_LOCAL_P (x) || !indirect;
 
   if (GET_CODE (x) == CONST)
-    return !flag_pic
+    return !GCC_OPTION (flag_pic)
 	   || GET_CODE (XEXP (XEXP (x, 0), 0)) != SYMBOL_REF
 	   || SYMBOL_REF_LOCAL_P (XEXP (XEXP (x, 0), 0));
 
@@ -1699,7 +1699,7 @@ indirectable_address_p (rtx x, bool strict, bool indirect)
     return true;
   if (GET_CODE (x) != PLUS
       || !BASE_REGISTER_P (XEXP (x, 0), strict)
-      || (flag_pic && !CONST_INT_P (XEXP (x, 1))))
+      || (GCC_OPTION (flag_pic) && !CONST_INT_P (XEXP (x, 1))))
     return false;
   return indirectable_constant_address_p (XEXP (x, 1), indirect);
 }
@@ -1789,8 +1789,8 @@ indexable_address_p (rtx xfoo0, rtx xfoo1, enum machine_mode mode, bool strict)
   if (!CONSTANT_ADDRESS_P (xfoo0))
     return false;
   if (BASE_REGISTER_P (xfoo1, strict))
-    return !flag_pic || mode == QImode;
-  if (flag_pic && symbolic_operand (xfoo0, SImode))
+    return !GCC_OPTION (flag_pic) || mode == QImode;
+  if (GCC_OPTION (flag_pic) && symbolic_operand (xfoo0, SImode))
     return false;
   return reg_plus_index_p (xfoo1, mode, strict);
 }
@@ -1854,9 +1854,9 @@ vax_mode_dependent_address_p (const_rtx x, addr_space_t as ATTRIBUTE_UNUSED)
     return false;
   if (CONST_INT_P (xfoo1) && REG_P (xfoo0))
     return false;
-  if (!flag_pic && CONSTANT_ADDRESS_P (xfoo0) && REG_P (xfoo1))
+  if (!GCC_OPTION (flag_pic) && CONSTANT_ADDRESS_P (xfoo0) && REG_P (xfoo1))
     return false;
-  if (!flag_pic && CONSTANT_ADDRESS_P (xfoo1) && REG_P (xfoo0))
+  if (!GCC_OPTION (flag_pic) && CONSTANT_ADDRESS_P (xfoo1) && REG_P (xfoo0))
     return false;
 
   return true;
@@ -1871,7 +1871,7 @@ fixup_mathdi_operand (rtx x, enum machine_mode mode)
       rtx temp = gen_reg_rtx (Pmode);
       rtx offset = 0;
 #ifdef NO_EXTERNAL_INDIRECT_ADDRESS
-      if (GET_CODE (addr) == CONST && flag_pic)
+      if (GET_CODE (addr) == CONST && GCC_OPTION (flag_pic))
 	{
 	  offset = XEXP (XEXP (addr, 0), 1);
 	  addr = XEXP (XEXP (addr, 0), 0);
diff --git a/gcc/config/vms/vms-c.c b/gcc/config/vms/vms-c.c
index 6c71104..aebc786 100644
--- a/gcc/config/vms/vms-c.c
+++ b/gcc/config/vms/vms-c.c
@@ -72,7 +72,7 @@ vms_pragma_member_alignment (cpp_reader *pfile ATTRIBUTE_UNUSED)
   if (tok == CPP_EOF)
     {
       /* Disable packing.  */
-      maximum_field_alignment = initial_max_fld_align;
+      maximum_field_alignment = GCC_OPTION (initial_max_fld_align);
       return;
     }
   if (tok != CPP_NAME)
@@ -337,7 +337,7 @@ static void
 vms_pragma_pointer_size (cpp_reader * ARG_UNUSED (dummy))
 {
   /* Ignore if no -mpointer-size option.  */
-  if (flag_vms_pointer_size == VMS_POINTER_SIZE_NONE)
+  if (GCC_OPTION (flag_vms_pointer_size) == VMS_POINTER_SIZE_NONE)
     return;
 
   handle_pragma_pointer_size ("pointer_size");
@@ -455,10 +455,10 @@ void
 vms_c_common_override_options (void)
 {
   /* Allow variadic functions without parameters (as declared in starlet).  */
-  flag_allow_parameterless_variadic_functions = TRUE;
+  GCC_OPTION (flag_allow_parameterless_variadic_functions) = TRUE;
 
   /* Initialize c_default_pointer_mode.  */
-  switch (flag_vms_pointer_size)
+  switch (GCC_OPTION (flag_vms_pointer_size))
     {
     case VMS_POINTER_SIZE_NONE:
       break;
diff --git a/gcc/config/vms/vms.c b/gcc/config/vms/vms.c
index 0a8a5b8..cd298d8 100644
--- a/gcc/config/vms/vms.c
+++ b/gcc/config/vms/vms.c
@@ -150,7 +150,7 @@ vms_patch_builtins (void)
 
       /* Discard 32ONLY if using 64 bit pointers.  */
       if ((n->flags & VMS_CRTL_32ONLY)
-	  && flag_vms_pointer_size == VMS_POINTER_SIZE_64)
+	  && GCC_OPTION (flag_vms_pointer_size) == VMS_POINTER_SIZE_64)
 	continue;
 
       /* Handle DPML unless overridden by decc.  */
@@ -255,10 +255,10 @@ vms_patch_builtins (void)
           vms_add_crtl_xlat (alt, nlen + 3, res, rlen + nlen);
 
           use_64 = (((n->flags & VMS_CRTL_64)
-                     && flag_vms_pointer_size == VMS_POINTER_SIZE_64)
+                     && GCC_OPTION (flag_vms_pointer_size) == VMS_POINTER_SIZE_64)
                     || ((n->flags & VMS_CRTL_MALLOC)
-                        && flag_vms_malloc64
-                        && flag_vms_pointer_size != VMS_POINTER_SIZE_NONE));
+                        && GCC_OPTION (flag_vms_malloc64)
+                        && GCC_OPTION (flag_vms_pointer_size) != VMS_POINTER_SIZE_NONE));
           if (!use_64)
             vms_add_crtl_xlat (n->name, nlen, res, rlen + nlen);
 
@@ -299,14 +299,14 @@ void
 vms_start_function (const char *fnname)
 {
 #if VMS_DEBUGGING_INFO
-  if (vms_debug_main
-      && debug_info_level > DINFO_LEVEL_NONE
-      && strncmp (vms_debug_main, fnname, strlen (vms_debug_main)) == 0)
+  if (GCC_OPTION (vms_debug_main)
+      && GCC_OPTION (debug_info_level) > DINFO_LEVEL_NONE
+      && strncmp (GCC_OPTION (vms_debug_main), fnname, strlen (GCC_OPTION (vms_debug_main))) == 0)
     {
       targetm.asm_out.globalize_label (asm_out_file, VMS_DEBUG_MAIN_POINTER);
       ASM_OUTPUT_DEF (asm_out_file, VMS_DEBUG_MAIN_POINTER, fnname);
       dwarf2out_vms_debug_main_pointer ();
-      vms_debug_main = 0;
+      GCC_OPTION (vms_debug_main) = 0;
     }
 #endif
 
@@ -316,9 +316,9 @@ vms_start_function (const char *fnname)
     {
       unsigned int flags = 0;
 
-      if (flag_vms_pointer_size == VMS_POINTER_SIZE_64)
+      if (GCC_OPTION (flag_vms_pointer_size) == VMS_POINTER_SIZE_64)
 	flags |= MAIN_FLAG_64BIT;
-      if (!flag_vms_return_codes)
+      if (!GCC_OPTION (flag_vms_return_codes))
 	flags |= MAIN_FLAG_POSIX;
 
       targetm.asm_out.globalize_label (asm_out_file, VMS_MAIN_FLAGS_SYMBOL);
diff --git a/gcc/config/vms/vms.h b/gcc/config/vms/vms.h
index dabc351..8dfccd9 100644
--- a/gcc/config/vms/vms.h
+++ b/gcc/config/vms/vms.h
@@ -28,9 +28,9 @@ along with GCC; see the file COPYING3.  If not see
     builtin_assert ("system=vms");					 \
     SUBTARGET_OS_CPP_BUILTINS();					 \
     builtin_define ("__int64=long long");				 \
-    if (flag_vms_pointer_size == VMS_POINTER_SIZE_32)			 \
+    if (GCC_OPTION (flag_vms_pointer_size) == VMS_POINTER_SIZE_32)			 \
       builtin_define ("__INITIAL_POINTER_SIZE=32");			 \
-    else if (flag_vms_pointer_size == VMS_POINTER_SIZE_64)		 \
+    else if (GCC_OPTION (flag_vms_pointer_size) == VMS_POINTER_SIZE_64)		 \
       builtin_define ("__INITIAL_POINTER_SIZE=64");			 \
     if (POINTER_SIZE == 64)						 \
       builtin_define ("__LONG_POINTERS=1");				 \
@@ -57,7 +57,7 @@ extern void vms_c_register_includes (const char *, const char *, int);
 
 /* Pointer is 32 bits but the hardware has 64-bit addresses, sign extended.  */
 #undef POINTER_SIZE
-#define POINTER_SIZE (flag_vms_pointer_size == VMS_POINTER_SIZE_NONE ? 32 : 64)
+#define POINTER_SIZE (GCC_OPTION (flag_vms_pointer_size) == VMS_POINTER_SIZE_NONE ? 32 : 64)
 #define POINTERS_EXTEND_UNSIGNED 0
 
 /* Always a 32 bit type.  */
@@ -66,10 +66,10 @@ extern void vms_c_register_includes (const char *, const char *, int);
 
 /* ???: Defined as a 'int' by dec-c, but obstack.h doesn't like it.  */
 #undef PTRDIFF_TYPE
-#define PTRDIFF_TYPE (flag_vms_pointer_size == VMS_POINTER_SIZE_NONE ? \
+#define PTRDIFF_TYPE (GCC_OPTION (flag_vms_pointer_size) == VMS_POINTER_SIZE_NONE ? \
                       "int" : "long long int")
 
-#define SIZETYPE (flag_vms_pointer_size == VMS_POINTER_SIZE_NONE ? \
+#define SIZETYPE (GCC_OPTION (flag_vms_pointer_size) == VMS_POINTER_SIZE_NONE ? \
 		  "unsigned int" : "long long unsigned int")
 
 #define C_COMMON_OVERRIDE_OPTIONS vms_c_common_override_options ()
diff --git a/gcc/config/vxworks.c b/gcc/config/vxworks.c
index bd5e735..6f94b69 100644
--- a/gcc/config/vxworks.c
+++ b/gcc/config/vxworks.c
@@ -141,14 +141,14 @@ vxworks_override_options (void)
   targetm.have_ctors_dtors = TARGET_VXWORKS_RTP;
 
   /* PIC is only supported for RTPs.  */
-  if (flag_pic && !TARGET_VXWORKS_RTP)
+  if (GCC_OPTION (flag_pic) && !TARGET_VXWORKS_RTP)
     error ("PIC is only supported for RTPs");
 
   /* Default to strict dwarf-2 to prevent potential difficulties observed with
      non-gdb debuggers on extensions > 2.  */
   if (!global_options_set.x_dwarf_strict)
-    dwarf_strict = 1;
+    GCC_OPTION (dwarf_strict) = 1;
 
   if (!global_options_set.x_dwarf_version)
-    dwarf_version = 2;
+    GCC_OPTION (dwarf_version) = 2;
 }
diff --git a/gcc/config/xtensa/xtensa.c b/gcc/config/xtensa/xtensa.c
index 06e1eb7..c9d9af3 100644
--- a/gcc/config/xtensa/xtensa.c
+++ b/gcc/config/xtensa/xtensa.c
@@ -1256,7 +1256,7 @@ xtensa_expand_block_move (rtx *operands)
   rtx x;
 
   /* If this is not a fixed size move, just call memcpy.  */
-  if (!optimize || (GET_CODE (operands[2]) != CONST_INT))
+  if (!GCC_OPTION (optimize) || (GET_CODE (operands[2]) != CONST_INT))
     return 0;
 
   bytes = INTVAL (operands[2]);
@@ -1271,7 +1271,7 @@ xtensa_expand_block_move (rtx *operands)
 
   /* Decide whether to expand inline based on the optimization level.  */
   move_ratio = 4;
-  if (optimize > 2)
+  if (GCC_OPTION (optimize) > 2)
     move_ratio = LARGEST_MOVE_RATIO;
   num_pieces = (bytes / align) + (bytes % align); /* Close enough anyway.  */
   if (num_pieces > move_ratio)
@@ -2222,30 +2222,30 @@ xtensa_option_override (void)
 
   /* Check PIC settings.  PIC is only supported when using L32R
      instructions, and some targets need to always use PIC.  */
-  if (flag_pic && TARGET_CONST16)
+  if (GCC_OPTION (flag_pic) && TARGET_CONST16)
     error ("-f%s is not supported with CONST16 instructions",
-	   (flag_pic > 1 ? "PIC" : "pic"));
+	   (GCC_OPTION (flag_pic) > 1 ? "PIC" : "pic"));
   else if (TARGET_FORCE_NO_PIC)
-    flag_pic = 0;
+    GCC_OPTION (flag_pic) = 0;
   else if (XTENSA_ALWAYS_PIC)
     {
       if (TARGET_CONST16)
 	error ("PIC is required but not supported with CONST16 instructions");
-      flag_pic = 1;
+      GCC_OPTION (flag_pic) = 1;
     }
   /* There's no need for -fPIC (as opposed to -fpic) on Xtensa.  */
-  if (flag_pic > 1)
-    flag_pic = 1;
-  if (flag_pic && !flag_pie)
-    flag_shlib = 1;
+  if (GCC_OPTION (flag_pic) > 1)
+    GCC_OPTION (flag_pic) = 1;
+  if (GCC_OPTION (flag_pic) && !GCC_OPTION (flag_pie))
+    GCC_OPTION (flag_shlib) = 1;
 
   /* Hot/cold partitioning does not work on this architecture, because of
      constant pools (the load instruction cannot necessarily reach that far).
      Therefore disable it on this architecture.  */
-  if (flag_reorder_blocks_and_partition)
+  if (GCC_OPTION (flag_reorder_blocks_and_partition))
     {
-      flag_reorder_blocks_and_partition = 0;
-      flag_reorder_blocks = 1;
+      GCC_OPTION (flag_reorder_blocks_and_partition) = 0;
+      GCC_OPTION (flag_reorder_blocks) = 1;
     }
 }
 
@@ -2517,7 +2517,7 @@ xtensa_output_addr_const_extra (FILE *fp, rtx x)
 	  fputs ("@DTPOFF", fp);
 	  return true;
 	case UNSPEC_PLT:
-	  if (flag_pic)
+	  if (GCC_OPTION (flag_pic))
 	    {
 	      output_addr_const (fp, XVECEXP (x, 0, 0));
 	      fputs ("@PLT", fp);
diff --git a/gcc/config/xtensa/xtensa.h b/gcc/config/xtensa/xtensa.h
index c4a8f88..8519687 100644
--- a/gcc/config/xtensa/xtensa.h
+++ b/gcc/config/xtensa/xtensa.h
@@ -553,7 +553,7 @@ typedef struct xtensa_args
 #define FUNCTION_PROFILER(FILE, LABELNO) \
   do {									\
     fprintf (FILE, "\t%s\ta10, a0\n", TARGET_DENSITY ? "mov.n" : "mov"); \
-    if (flag_pic)							\
+    if (GCC_OPTION (flag_pic))							\
       {									\
 	fprintf (FILE, "\tmovi\ta8, _mcount@PLT\n");			\
 	fprintf (FILE, "\tcallx8\ta8\n");				\
@@ -752,7 +752,7 @@ typedef struct xtensa_args
 
 /* Indicate that jump tables go in the text section.  This is
    necessary when compiling PIC code.  */
-#define JUMP_TABLES_IN_TEXT_SECTION (flag_pic)
+#define JUMP_TABLES_IN_TEXT_SECTION (GCC_OPTION (flag_pic))
 
 
 /* Define the strings to put out for each section in the object file.  */
@@ -766,7 +766,7 @@ typedef struct xtensa_args
   do {									\
     if ((SIZE) > 0)							\
       {									\
-	resolve_unique_section ((FUNDECL), 0, flag_function_sections);	\
+	resolve_unique_section ((FUNDECL), 0, GCC_OPTION (flag_function_sections));	\
 	switch_to_section (function_section (FUNDECL));			\
 	fprintf (FILE, "\t.literal_position\n");			\
       }									\
@@ -794,7 +794,7 @@ typedef struct xtensa_args
 #define DWARF_FRAME_REGISTERS 16
 #define EH_RETURN_DATA_REGNO(N) ((N) < 2 ? (N) + 2 : INVALID_REGNUM)
 #define ASM_PREFERRED_EH_DATA_FORMAT(CODE, GLOBAL)			\
-  (flag_pic								\
+  (GCC_OPTION (flag_pic)								\
    ? (((GLOBAL) ? DW_EH_PE_indirect : 0)				\
       | DW_EH_PE_pcrel | DW_EH_PE_sdata4)				\
    : DW_EH_PE_absptr)
